{$ifdef VIRTUALPASCAL}
        {$ifdef WIN32}
                {$define FORWIN}
        {$endif}

        {$ifdef OS2}
                {$define FOROS2}
        {$endif}

{$else}
    {$ifdef FPC}
        {$define FORNIX}
    {$else}
        {$define FORDOS}
    {$endif}
{$endif}


{$define DEBUG}


(*****************************************************************)
(********************* COMPILER DIRECTIVES ***********************)
(*****************************************************************)


{$ifdef FORDOS}
{.$M 65000, 100000, 655000} (* This reserves memory for use by this program.
                              This is not necessary for 32bit platforms
                              such as win32 and linux *)

{$O+}

{$endif}

(* The following compiler directives can be set as the default in your
   compiler's IDE. I've included them here so you can see what I use. *)

{$V-} (* Allow any size string to be passed to procedures. If you do a
         procedure foo(bar:string) and baz:string[3] and then try to do
         foo(baz) you would get a compiler error without $V- *)
{$P+} (* Strings in procedure typecasts can be of any size .. Here for
         compatibility with older version of turbo pascal *)
{$S+} (* Stack checking on. With stack checking on, the program will
         generate a run time error if there is not enough memory for the
         needed variables. With stack checking off, you're likely to have
         a system crash if theres not enough memory. This is good to have
         on all of the time. *)
{$I+} (* I/O Checking on. With I/O checking on, the program will generate
         a run time error if there is a problem when reading/writing to files.
         If I/O checking is off, you have to manually check IOResult each
         time you call an I/O routine. You could move this to the debug
         section, but its better outside of the debug section. *)


(*
Debugger Info   : This adds more information to the produced exe for use
                  with the compiler's debugger program. Specifically,
                  it records line numbers.
Local Symbols   : This adds more information to the produced exe for use
                  with the compiler's debugger program. Specifically, you
                  can view the call stack after a run time error.
Symbol Ref Info : This adds more information to the produced exe for use
                  with the compiler's debugger program. Specifically, this
                  allows use of the debugger's object browser.
Range Checking  : Values assigned to variables are checked to make sure
                  they are within the range of that variable type. If range
                  checking is on, and you assigned a value that was out of
                  range, a run time error would be generated. If range
                  checking is off, the variable is 'wrapped' instead.

Note that $D, $L, and $Y are only good when used in conjunction with
the debugger.
*)
{$ifdef DEBUG}
  {$D+} (* Debugger info on *)
  {$L+} (* Local symbol info on *)
  {$Y+} (* Symbol reference info on *)
  {$R+} (* Range checking on.  *)
{$else}
  {$D-} (* Debugger info off *)
  {$L-} (* Local symbol info off *)
  {$Y-} (* Symbol reference info off *)
  {.$R+} (* Range checking off *)
{$endif}

(*****************************************************************)
(************* PLATFORM SPECIFIC COMPILER DIRECTIVES *************)
(*****************************************************************)


{$ifndef FORDOS}
{$H-} (* Turn ansistrings off. On dos, variables of type string are limited
         to 255 characters. On Win32, *nix, and os2, variables of type
         string can be as long as the system's memory allows. By turning
         ansistrings off, we can be certain what length string we have. *)
{$endif}


{$ifdef FPC}           (* When Free Pascal is used, FPC is defined
                          by the compiler. *)
{$PACKRECORDS 1}       (* By default, FP uses a byte alignment of 2.
                          Turbo Pascal uses a byte alignment of 1. By
                          declaring '$PACKRECORDS 1' we're making sure
                          that data files can be shared between TP exe's
                          and FP exe's *)
{$MODE TP}             (* Since Turbo Pascal is a 16bit language, it has
                          a few limitations that Free Pascal doesn't have.
                          By declaring '$MODE TP', we're ensuring that
                          FP treats our code the same way that TP would. *)
{$endif}

{$ifdef VIRTUALPASCAL} (* When Virtual Pascal is used, VIRTUALPASCAL
                          is defined by the compiler. *)
{&AlignRec-}           (* By default, VP uses a byte alignment of 2.
                          Turbo Pascal uses a byte alignment of 1. By
                          declaring '&AlignRec-' we're making sure that
                          data files can be shared between TP exe's
                          and VP exe's *)
{&Use32-}              (* Since VP is a 32bit language, the size of VP's
                          base variable types are 32bit. For example, an
                          integer in Use32+ would be 32bit, but in
                          Use32- it would be 16bit. TP is a 16bit language.
                          So, by declaring 'Use32-' we're ensuring that we
                          use the same datatypes for TP and VP. *)
{&Delphi-}             (* Turn off Delphi syntax support *)
{$endif}

